<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: data/proxy/REST.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: data/proxy/REST.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'uweaver/lang', 'uweaver/data/proxy/Proxy', 'uweaver/environment',
    'uweaver/net', 'uweaver/number'], function(_, lang, Proxy, env, net, number) {
    var declare = lang.declare;
    var Base = Proxy;

    /**
     * REST persist the state of a model/collection to the server
     *
     * @constructor Proxy
     * @extends Proxy
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [options] - optional configuration.
     */
    function initialize(options) {
        Base.prototype.initialize.apply(this, arguments);

        options || (options = {});

        var defaults = {};

        _.defaults(options, defaults);

        var REST = env.get("REST", {});

        this._server = options.server || REST.server;
        this._port = options.port || REST.port;
        this._context = options.context || REST.context;
    }

    function request(resource, subresource, data, options) {
        options || (options = {});

        var defaults = {
            data: {}
        };

        _.defaults(options, defaults);

        var settings = {};

        _.defaults(settings, options);

        if (settings.method === 'POST') {
            var formData = new FormData();

            _.each(parseFiles(settings.data), function (file) {
                formData.append('attachments', file);
            });
            formData.append('payload', JSON.stringify(settings.data));
            settings.contentType = false;
            settings.processData = false;
            settings.cache = false;
            settings.data = formData;
        }

        return net.request(this.url(resource, data.id, subresource), settings);
    }

    /**
     * @override
     */
    function sync(resource, action, data, options) {
        options || (options = {});

        switch(action) {
            case 'create':
                return create.call(this, resource, data, options);
            case 'update':
                return update.call(this, resource, data, options);
            case 'patch':
                return update.call(this, resource, data, options);
            case 'delete':
                return erase.call(this, resource, data, options);
            case 'read':
                return read.call(this, resource, data, options);
            default:
                return customAction.call(this, resource, action, data, options);
        }
    }

    function customAction(resource, action, data, options) {
        options || (options = {});

        var defaults = {
            data: {}
        };

        _.defaults(options, defaults);

        var settings = {};

        _.defaults(settings, options);

        if(settings.method==='POST') {
            var formData = new FormData();

            _.each(parseFiles(settings.data), function(file) {
                formData.append('attachments', file);
            });
            formData.append('payload', JSON.stringify(settings.data));
            settings.contentType = false;
            settings.processData = false;
            settings.cache = false;
            settings.data = formData;
        }

        return net.request(this.url(resource, data.id, action), settings);
    }

    function create(resource, data, options) {
        var formData = new FormData();

        _.each(parseFiles(data), function(file) {
            formData.append('attachments', file);
        });
        formData.append('payload', JSON.stringify(data.toJSON()));

        var settings = {
            data: formData,
            method: "POST",
            contentType: false,
            processData: false,
            cache: false
        };
        
        _.defaults(settings, options);

        return net.request(this.url(resource, data.id), settings);
    }

    function read(resource, data, options) {
        var defaults = {};

        _.defaults(options, defaults);

        var settings = {
            method: "GET",
            data: {}
        };

        _.defaults(settings.data, options.data);

        _.isFunction(data.filters) &amp;&amp; (settings.data.filters = JSON.stringify(data.filters()));
        _.isFunction(data.sorters) &amp;&amp; (settings.data.sorters = JSON.stringify(data.sorters()));
        _.isFunction(data.limit) &amp;&amp; (settings.data.limit = data.limit());
        _.isFunction(data.offset) &amp;&amp; (settings.data.offset = data.offset());
        _.isFunction(data.conjunction) &amp;&amp; (settings.data.conjunction = data.conjunction());

        _.defaults(settings, options);

        settings.success = function(response, status, xhr) {
            /**
             * @todo check if data has size or total method instead of check if response is an array.
             */
            if(_.isArray(response) &amp;&amp; (xhr.getResponseHeader('Item-Count')!==null)) {
                data._total = number.parse(xhr.getResponseHeader('Item-Count'));
            }
            _.isFunction(options.success) &amp;&amp; options.success.apply(this, arguments);
        };

        return net.request(this.url(resource, data.id), settings);
    }

    function update(resource, data, options) {
        var formData = new FormData();

        _.each(parseFiles(data), function(file) {
            formData.append('attachments', file);
        });

        formData.append('payload', JSON.stringify(data.toJSON()));

        var settings = {
            data: formData,
            method: "POST",
            contentType: false,
            processData: false,
            cache: false
        };

        _.defaults(settings, options);

        return net.request(this.url(resource, data.id), settings);
    }

    function parseFiles(data) {
        if(!data) return [];

        return _.isArray(data) ? parseFilesFromItems(data) : parseFilesFromItem(data);
    }

    function parseFilesFromItem(data) {
        var files = [];
        var item = _.isFunction(data.toJSON) ? data.toJSON() : data;

        if(!item) return [];

        _.each(item, function(value) {
            if(value instanceof File) {
                files.push(value);
                value.toJSON = fileToJSON;
            } else if(_.isArray(value)) {
                files = files.concat(parseFilesFromItems(value));
            } else if(!isPrimitive(value)) {
                files = files.concat(parseFilesFromItem(value))
            }
        });

        return files;
    }

    function parseFilesFromItems(data) {
        var files = [];
        var items = data;

        if(!items) return [];

        _.each(items, function(item) {
            if(item instanceof File) {
                files.push(item);
                item.toJSON = fileToJSON;
            } else if(!isPrimitive(item)) {
                files = files.concat(parseFilesFromItem(item));
            }
        });

        return files;
    }

    function isPrimitive(value) {
        if(!_.isObject(value)) return true;
        if(_.isDate(value)) return true;
        if(_.isNumber(value)) return true;
        if(_.isString(value)) return true;
        if(_.isBoolean(value)) return true;

        return false;
    }

    function fileToJSON() {
        var json = {};

        _.each(this, function(value, key) {
            json[key] = value;
        });

        json.name = this.name;
        json.type = this.type;
        json.size = this.size;

        return json;
    }


    function erase(resource, data, options) {
        var settings = {
            method: "DELETE"
        };

        _.defaults(settings, options);

        var promise = net.request(this.url(resource, data.id), settings);

        return promise;
    }

    function url(resource, id, action) {
        var url = "";

        if(this._server) {
            url = 'http://' + this._server;
            if(this._port) {
                url = url + ':' + this._port;
            }
        }

        this._context &amp;&amp; (url = url + this._context);

        url = url + '/' + resource;

        if(id) {
            url = url + '/' + id;
        }

        action &amp;&amp; (url = url + '/' + action);

        url = url + '/';

        return url;
    }


    function dataUrl(url) {

        if(/^(http|\/){1}/.test(url)) return url;

        var dataUrl = "";
        if(this._server) {
            dataUrl = 'http://' + this._server;
            if(this._port) {
                dataUrl = dataUrl + ':' + this._port;
            }
        }

        this._context &amp;&amp; (dataUrl = dataUrl + this._context);

        dataUrl = dataUrl + '/' + url;


        return dataUrl;
    }


    var props = {
        _server: undefined,
        _port: undefined,
        _context: undefined
    };

    var REST = declare(Base, {
        initialize: initialize,
        sync: sync,
        request: request,
        url: url,
        dataUrl: dataUrl
    }, props);

    return REST;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
